uniform mat4 mvp;

in vec4 Position;
in vec2 TexCoord;
						   
uniform lowp vec2 pixelsPerCell;
uniform lowp vec2 offset;
out lowp float velocity;
out lowp vec2 tc;

void main () {
	vec2 pos = Position.xy;
	velocity = Position.w;
	pos *= pixelsPerCell;
	pos -= offset;

	pos.x += 2.f;
	pos.y += 2.f;
	pos.x = floor(pos.x/2.f) * 2.f;
	// pos.y = floor(pos.y/2.f) * 2.f;

	pos -= TexCoord * 2.0;

	tc = TexCoord;

	float thickness = 2.f;
	
	// Position.z is width, height = 1
	vec2 actualDims = vec2(Position.z, 1.0) * pixelsPerCell;

	vec2 inset = vec2(thickness) / actualDims;
	vec2 amt = tc *2.0 - vec2(1.0);
	tc += inset * amt;
	
	gl_Position = mvp * vec4(pos, 0.f, 1.f);
}
